package
{
	import flash.filters.*;
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.external.*;
	import flash.geom.*;
	import mx.utils.*;
	import mx.events.*;
	import caurina.transitions.*;
	
	[SWF(width="400", height="630", backgroundColor="#000000")] 
	public class FieldViewAdobe extends FieldView
	{
		override protected function get SIZE():int
		{
			return 30;
		}

		private var blocks:Array;
		
		// images
		[Embed(source="images/adobe-aqua.png")]
		private var aqua:Class;
		[Embed(source="images/adobe-blue.png")]
		private var blue:Class;
		[Embed(source="images/adobe-green.png")]
		private var green:Class;
		[Embed(source="images/adobe-logo.png")]
		private var logo:Class;
		[Embed(source="images/adobe-orange.png")]
		private var orange:Class;
		[Embed(source="images/adobe-purple.png")]
		private var purple:Class;
		[Embed(source="images/adobe-red.png")]
		private var red:Class;
		[Embed(source="images/adobe-white.png")]
		private var white:Class;
		[Embed(source="images/adobe-yellow.png")]
		private var yellow:Class;

		public function FieldViewAdobe()
		{
			blocks = [];
			blocks.push(Bitmap(new aqua).bitmapData);
			blocks.push(Bitmap(new yellow).bitmapData);
			blocks.push(Bitmap(new green).bitmapData);
			blocks.push(Bitmap(new red).bitmapData);
			blocks.push(Bitmap(new blue).bitmapData);
			blocks.push(Bitmap(new orange).bitmapData);
			blocks.push(Bitmap(new purple).bitmapData);
			blocks.push(Bitmap(new logo).bitmapData);

			super();
		}

		// draw block
		override protected function drawBlock(bitmap:BitmapData, kind:String):void
		{
			var index:int = Tetrimino.kinds.indexOf(kind);
			if(index != -1 && index < blocks.length)
			{
				var block:BitmapData = blocks[index];
				bitmap.copyPixels(block, block.rect, new Point(0, 0));
			}
		}
	}
}