package
{
	import flash.filters.*;
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.external.*;
	import flash.geom.*;
	import mx.utils.*;
	import mx.events.*;
	import caurina.transitions.*;
	
	[SWF(width="300", height="450", backgroundColor="#000000")] 
	public class FieldViewExt2 extends FieldView
	{
		public function FieldViewExt2()
		{
			super();

			for(var i:int = 0; i < Field.WIDTH - 1; i++)
			{
				for(var j:int = Field.HEIGHT - 3; j < Field.HEIGHT; j++)
				{
					field.boxes.setAt(i, j, "I");
				}
			}
			field.addEventListener("disapear", onDisapear);
		}

		// draw block
		override protected function drawBlock(bitmap:BitmapData, kind:String):void
		{
			var size:int = SIZE - 1;

			var color:int = Tetrimino.colorList[kind];
			bitmap.fillRect(new Rectangle(0, 0, size, size), color | 0xff000000);

			var filter:BevelFilter = new BevelFilter(2, 45, 0xffffff, 0.5, 0x000000, 0.5, 2, 2);
			bitmap.applyFilter(bitmap, bitmap.rect, new Point(0, 0), filter);
		}

		// disapear effect
		private function onDisapear(event:DynamicEvent):void
		{
			redraw();

			var line:Array = event.line;
			trace(line);
			var bmpEffect:Bitmap = new Bitmap();
			bmpEffect.bitmapData = new BitmapData(SIZE * Field.WIDTH, SIZE * Field.HEIGHT, true, 0);

			for each(var num:int in line)
			{
				trace(num);
				var rect:Rectangle = new Rectangle(0, num * SIZE, SIZE * Field.WIDTH, SIZE);
				bmpEffect.bitmapData.copyPixels(bmpField.bitmapData, rect, new Point(0, num * SIZE));
				bmpField.bitmapData.fillRect(rect, 0xff000000);
			}
			bmpEffect.x = SIZE;
			addChild(bmpEffect);

			field.pause();

			Tweener.addTween(bmpEffect, {
				alpha : 0, 
				time : .5,
				transition : "easeinbounce",
				onComplete : function():void
				{
					field.play();
				}
			});
		}
	}
}